# -*- encoding: utf-8 -*-
##############################################################################
#
#    ETL system- Extract Transfer Load system
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
"""
 Puts job process in sleep.

 Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
 GNU General Public License.

"""

from etl.component import component
import time

class sleep(component):
    """
    Puts job process in sleep.
    """
    def __init__(self, delay=1, name='component.control.sleep'):
        """
        Parameters
        delay        : Delay in Seconds
        name         : Name of Component.
        """
        super(sleep, self).__init__(name)
        self._type = 'component.control.sleep'
        self.delay = delay

    def __copy__(self):
        res = sleep(self.delay, self.name)
        return res

    def process(self):
        for channel, trans in self.input_get().items():
            for iterator in trans:
                for d in iterator:
                    time.sleep(self.delay)
                    yield d, 'main'
    def __getstate__(self):
        res = super(sleep, self).__getstate__()
        res.update({'delay':self.delay})
        return res

    def __setstate__(self, state):
        super(sleep, self).__setstate__(state)
        self.__dict__ = state

